/*
 * nScore
 *
 * score_01_list.c
 *
 * Copyright (C) 1996-2005 by Nakashima Tomoaki. All rights reserved.
 *		http://www.nakka.com/
 *		nakka@nakka.com
 */

/* Include Files */
#define _INC_OLE
#include <windows.h>
#undef  _INC_OLE
#include <commctrl.h>
#include <tchar.h>
#include <stdio.h>

#include "General.h"
#include "String.h"
#include "Message.h"
#include "score_01.h"
#include "score_input.h"

#include "resource.h"

/* Define */
#define WM_CHANGE_VIEW				(WM_APP + 1)

#define IsNumeric(c)				(c >= TEXT('0') && c <= TEXT('9'))

/* Global Variables */

/* Local Function Prototypes */
static BOOL get_status(ZEROONE_INFO *zi, const int round, TCHAR *ret);
static void listview_set_score(const HWND hListView, ZEROONE_INFO *zi);
static BOOL CALLBACK score_01_list_proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);

/*
 * get_status - Xe[^X̎擾
 */
static BOOL get_status(ZEROONE_INFO *zi, const int round, TCHAR *ret)
{
	TCHAR throw_str[THROW_MAX][BUF_SIZE];
	int round_score;
	int i;

	if (round == 0) {
		round_score = zi->init_score - zi->pi[zi->list_index].ri[round].score_list;
	} else {
		round_score = zi->pi[zi->list_index].ri[round - 1].score_list - zi->pi[zi->list_index].ri[round].score_list;
	}
	for (i = 0; i < THROW_MAX; i++) {
		lstrcpy(throw_str[i], zi->pi[zi->list_index].ri[round].throw_list[i]);
		score_convert_str(throw_str[i]);
	}

	// BUST
	if (round_score == 0 &&
		(*throw_str[0] != TEXT('\0') || *throw_str[1] != TEXT('\0') || *throw_str[2] != TEXT('\0'))) {
		if (zi->pi[zi->list_index].double_in == TRUE &&
			(zi->pi[zi->list_index].double_in_flag == 0 ||
			zi->pi[zi->list_index].double_in_flag > round + 1)) {
			*ret = TEXT('\0');
			return TRUE;
		}
		lstrcpy(ret, message_get_res(IDS_STRING_BUST));
		return TRUE;
	}
	return get_status_string(throw_str, round_score, ret);
}

/*
 * listview_set_score - ListViewɃXRAǉ
 */
static void listview_set_score(const HWND hListView, ZEROONE_INFO *zi)
{
	LV_ITEM lvi;
	TCHAR buf[BUF_SIZE];
	int i, cnt;

	ListView_DeleteAllItems(hListView);

	cnt = zi->current_round;
	if ((zi->current_player <= zi->list_index && (zi->game_flag == TRUE || zi->current_player != zi->list_index)) ||
		(cnt > zi->round_cnt && zi->list_index == 0)) {
		cnt--;
	}
	for (i = 0; i < cnt; i++) {
		lvi.mask = LVIF_TEXT | LVIF_PARAM;
		lvi.iItem = i;
		lvi.iSubItem = 0;
		wsprintf(buf, TEXT("%d"), i + 1);
		lvi.pszText = buf;
		lvi.cchTextMax = BUF_SIZE - 1;
		lvi.iImage = 0;
		lvi.lParam = 0;
		ListView_InsertItem(hListView, &lvi);

		ListView_SetItemText(hListView, i, 1, zi->pi[zi->list_index].ri[i].throw_list[0]);
		ListView_SetItemText(hListView, i, 2, zi->pi[zi->list_index].ri[i].throw_list[1]);
		ListView_SetItemText(hListView, i, 3, zi->pi[zi->list_index].ri[i].throw_list[2]);

		if (i == 0) {
			wsprintf(buf, TEXT("%d"), zi->init_score - zi->pi[zi->list_index].ri[i].score_list);
		} else {
			wsprintf(buf, TEXT("%d"), zi->pi[zi->list_index].ri[i - 1].score_list - zi->pi[zi->list_index].ri[i].score_list);
		}
		ListView_SetItemText(hListView, i, 4, buf);

		wsprintf(buf, TEXT("%d"), zi->pi[zi->list_index].ri[i].score_list);
		ListView_SetItemText(hListView, i, 5, buf);

		if (get_status(zi, i, buf) == TRUE) {
			ListView_SetItemText(hListView, i, 6, buf);
		}
	}
}

/*
 * score_01_list_proc - EBhEvV[W
 */
static BOOL CALLBACK score_01_list_proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	ZEROONE_INFO *zi;
	LV_COLUMN lvc;
	TCHAR buf[BUF_SIZE];
	int i;

	switch (msg) {
	case WM_INITDIALOG:
		if ((zi = (ZEROONE_INFO *)lParam) == NULL) {
			EndDialog(hDlg, FALSE);
			break;
		}
		SetWindowLong(hDlg, GWL_USERDATA, lParam);

		// vC[ݒ
		for (i = 0; i < zi->player_cnt; i++) {
			SendDlgItemMessage(hDlg, IDC_COMBO_NAME, CB_ADDSTRING, 0, (LPARAM)zi->pi[i].name);
		}
		SendDlgItemMessage(hDlg, IDC_COMBO_NAME, CB_SETCURSEL, zi->list_index, 0);

		// Xgr[ݒ
		i = 0;
		lvc.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;

		lvc.fmt = LVCFMT_LEFT;
		lvc.cx = 60;
		lvc.pszText = message_get_res(IDS_STRING_LIST_ROUND);
		lvc.iSubItem = i++;
		ListView_InsertColumn(GetDlgItem(hDlg, IDC_LIST_SCORE), lvc.iSubItem, &lvc);

		lvc.fmt = LVCFMT_LEFT;
		lvc.cx = 80;
		lvc.pszText = message_get_res(IDS_STRING_LIST_THROW_1);
		lvc.iSubItem = i++;
		ListView_InsertColumn(GetDlgItem(hDlg, IDC_LIST_SCORE), lvc.iSubItem, &lvc);

		lvc.fmt = LVCFMT_LEFT;
		lvc.cx = 80;
		lvc.pszText = message_get_res(IDS_STRING_LIST_THROW_2);
		lvc.iSubItem = i++;
		ListView_InsertColumn(GetDlgItem(hDlg, IDC_LIST_SCORE), lvc.iSubItem, &lvc);

		lvc.fmt = LVCFMT_LEFT;
		lvc.cx = 80;
		lvc.pszText = message_get_res(IDS_STRING_LIST_THROW_3);
		lvc.iSubItem = i++;
		ListView_InsertColumn(GetDlgItem(hDlg, IDC_LIST_SCORE), lvc.iSubItem, &lvc);

		lvc.fmt = LVCFMT_LEFT;
		lvc.cx = 60;
		lvc.pszText = message_get_res(IDS_STRING_LIST_ROUND_SCORE);
		lvc.iSubItem = i++;
		ListView_InsertColumn(GetDlgItem(hDlg, IDC_LIST_SCORE), lvc.iSubItem, &lvc);

		lvc.fmt = LVCFMT_LEFT;
		lvc.cx = 60;
		lvc.pszText = message_get_res(IDS_STRING_LIST_SCORE);
		lvc.iSubItem = i++;
		ListView_InsertColumn(GetDlgItem(hDlg, IDC_LIST_SCORE), lvc.iSubItem, &lvc);

		lvc.fmt = LVCFMT_LEFT;
		lvc.cx = 100;
		lvc.pszText = message_get_res(IDS_STRING_LIST_STATUS);
		lvc.iSubItem = i++;
		ListView_InsertColumn(GetDlgItem(hDlg, IDC_LIST_SCORE), lvc.iSubItem, &lvc);

		// Xgr[̃X^C̐ݒ
		SetWindowLong(GetDlgItem(hDlg, IDC_LIST_SCORE), GWL_STYLE,
			GetWindowLong(GetDlgItem(hDlg, IDC_LIST_SCORE), GWL_STYLE) | LVS_SHOWSELALWAYS);
		SendDlgItemMessage(hDlg, IDC_LIST_SCORE, LVM_SETEXTENDEDLISTVIEWSTYLE, 0,
			LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES |
			SendDlgItemMessage(hDlg, IDC_LIST_SCORE, LVM_GETEXTENDEDLISTVIEWSTYLE, 0, 0));

	case WM_CHANGE_VIEW:
		zi = (ZEROONE_INFO *)GetWindowLong(hDlg, GWL_USERDATA);
		if (zi == NULL) {
			EndDialog(hDlg, FALSE);
			break;
		}
		zi->list_index = SendDlgItemMessage(hDlg, IDC_COMBO_NAME, CB_GETCURSEL, 0, 0);

		_stprintf(buf, message_get_res(IDS_STRING_AVERAGE), get_01_average(zi, zi->list_index, NULL, NULL));
		SetWindowText(GetDlgItem(hDlg, IDC_STATIC_AVERAGE), buf);

		// XRAݒ
		listview_set_score(GetDlgItem(hDlg, IDC_LIST_SCORE), zi);
		break;

	case WM_CLOSE:
		EndDialog(hDlg, FALSE);
		break;

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDC_COMBO_NAME:
			if(HIWORD(wParam) == CBN_SELCHANGE){
				SendMessage(hDlg, WM_CHANGE_VIEW, 0, 0);
			}
			break;

		case IDCANCEL:
			SendMessage(hDlg, WM_CLOSE, 0, 0);
			break;
		}
		break;

	default:
		return FALSE;
	}
	return TRUE;
}

/*
 * show_score_01_list - XRAꗗ\
 */
BOOL show_score_01_list(const HINSTANCE hInst, const HWND hWnd, ZEROONE_INFO *zi)
{
	return DialogBoxParam(hInst, MAKEINTRESOURCE(IDD_DIALOG_SCORE_LIST), hWnd, score_01_list_proc, (LPARAM)zi);
}
/* End of source */
