/*
 * nScore
 *
 * score_01_option.c
 *
 * Copyright (C) 1996-2005 by Nakashima Tomoaki. All rights reserved.
 *		http://www.nakka.com/
 *		nakka@nakka.com
 */

/* Include Files */
#define _INC_OLE
#include <windows.h>
#undef  _INC_OLE

#include "General.h"
#include "Message.h"
#include "score_01.h"
#include "ini.h"

#include "resource.h"

/* Define */

/* Global Variables */
extern TCHAR ini_path[MAX_PATH];

/* Local Function Prototypes */
static void set_enable(const HWND hDlg);
static BOOL CALLBACK option_01_proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);

/*
 * set_enable - Rg[̏Ԑݒ
 */
static void set_enable(const HWND hDlg)
{
	int i;

	if (IsDlgButtonChecked(hDlg, IDC_RADIO_P1) == 1) {
		i = 1;
	} else if (IsDlgButtonChecked(hDlg, IDC_RADIO_P2) == 1) {
		i = 2;
	} else if (IsDlgButtonChecked(hDlg, IDC_RADIO_P3) == 1) {
		i = 3;
	} else if (IsDlgButtonChecked(hDlg, IDC_RADIO_P4) == 1) {
		i = 4;
	}

	EnableWindow(GetDlgItem(hDlg, IDC_EDIT_P2), TRUE);
	EnableWindow(GetDlgItem(hDlg, IDC_EDIT_P3), TRUE);
	EnableWindow(GetDlgItem(hDlg, IDC_EDIT_P4), TRUE);
	EnableWindow(GetDlgItem(hDlg, IDC_CHECK_P2_D_IN), TRUE);
	EnableWindow(GetDlgItem(hDlg, IDC_CHECK_P3_D_IN), TRUE);
	EnableWindow(GetDlgItem(hDlg, IDC_CHECK_P4_D_IN), TRUE);
	EnableWindow(GetDlgItem(hDlg, IDC_CHECK_P2_D_OUT), TRUE);
	EnableWindow(GetDlgItem(hDlg, IDC_CHECK_P3_D_OUT), TRUE);
	EnableWindow(GetDlgItem(hDlg, IDC_CHECK_P4_D_OUT), TRUE);

	switch (i) {
	case 1:
		EnableWindow(GetDlgItem(hDlg, IDC_EDIT_P2), FALSE);
		EnableWindow(GetDlgItem(hDlg, IDC_CHECK_P2_D_IN), FALSE);
		EnableWindow(GetDlgItem(hDlg, IDC_CHECK_P2_D_OUT), FALSE);
	case 2:
		EnableWindow(GetDlgItem(hDlg, IDC_EDIT_P3), FALSE);
		EnableWindow(GetDlgItem(hDlg, IDC_CHECK_P3_D_IN), FALSE);
		EnableWindow(GetDlgItem(hDlg, IDC_CHECK_P3_D_OUT), FALSE);
	case 3:
		EnableWindow(GetDlgItem(hDlg, IDC_EDIT_P4), FALSE);
		EnableWindow(GetDlgItem(hDlg, IDC_CHECK_P4_D_IN), FALSE);
		EnableWindow(GetDlgItem(hDlg, IDC_CHECK_P4_D_OUT), FALSE);
		break;
	}
}

/*
 * option_01_proc - 01Q[ݒEBhEvV[W
 */
static BOOL CALLBACK option_01_proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	ZEROONE_INFO *zi;
	int i;

	switch (msg) {
	case WM_INITDIALOG:
		if ((zi = (ZEROONE_INFO *)lParam) == NULL) {
			EndDialog(hDlg, FALSE);
			break;
		}

		// XRAݒ
		EnableWindow(GetDlgItem(hDlg, IDC_EDIT_SCORE), FALSE);
		switch (zi->init_score) {
		case 301:
			CheckDlgButton(hDlg, IDC_RADIO_301, 1);
			break;
		case 501:
			CheckDlgButton(hDlg, IDC_RADIO_501, 1);
			break;
		case 1001:
			CheckDlgButton(hDlg, IDC_RADIO_1001, 1);
			break;
		default:
			CheckDlgButton(hDlg, IDC_RADIO_ETC, 1);
			EnableWindow(GetDlgItem(hDlg, IDC_EDIT_SCORE), TRUE);
			SetDlgItemInt(hDlg, IDC_EDIT_SCORE, zi->init_score, FALSE);
			break;
		}
		SetDlgItemInt(hDlg, IDC_EDIT_ROUND, zi->round_cnt, FALSE);

		// vC[ݒ
		switch (zi->player_cnt) {
		case 1:
			CheckDlgButton(hDlg, IDC_RADIO_P1, 1);
			break;
		case 2:
		default:
			CheckDlgButton(hDlg, IDC_RADIO_P2, 1);
			break;
		case 3:
			CheckDlgButton(hDlg, IDC_RADIO_P3, 1);
			break;
		case 4:
			CheckDlgButton(hDlg, IDC_RADIO_P4, 1);
			break;
		}
		// O
		SendDlgItemMessage(hDlg, IDC_EDIT_P1, WM_SETTEXT, 0,
			(LPARAM)((*zi->pi[0].name != TEXT('\0')) ? zi->pi[0].name : message_get_res(IDS_STRING_DEF_PLAYER_1)));
		SendDlgItemMessage(hDlg, IDC_EDIT_P2, WM_SETTEXT, 0,
			(LPARAM)((*zi->pi[1].name != TEXT('\0')) ? zi->pi[1].name : message_get_res(IDS_STRING_DEF_PLAYER_2)));
		SendDlgItemMessage(hDlg, IDC_EDIT_P3, WM_SETTEXT, 0,
			(LPARAM)((*zi->pi[2].name != TEXT('\0')) ? zi->pi[2].name : message_get_res(IDS_STRING_DEF_PLAYER_3)));
		SendDlgItemMessage(hDlg, IDC_EDIT_P4, WM_SETTEXT, 0,
			(LPARAM)((*zi->pi[3].name != TEXT('\0')) ? zi->pi[3].name : message_get_res(IDS_STRING_DEF_PLAYER_4)));
		// _uC
		CheckDlgButton(hDlg, IDC_CHECK_P1_D_IN, zi->pi[0].double_in);
		CheckDlgButton(hDlg, IDC_CHECK_P2_D_IN, zi->pi[1].double_in);
		CheckDlgButton(hDlg, IDC_CHECK_P3_D_IN, zi->pi[2].double_in);
		CheckDlgButton(hDlg, IDC_CHECK_P4_D_IN, zi->pi[3].double_in);
		// _uAEg
		CheckDlgButton(hDlg, IDC_CHECK_P1_D_OUT, zi->pi[0].double_out);
		CheckDlgButton(hDlg, IDC_CHECK_P2_D_OUT, zi->pi[1].double_out);
		CheckDlgButton(hDlg, IDC_CHECK_P3_D_OUT, zi->pi[2].double_out);
		CheckDlgButton(hDlg, IDC_CHECK_P4_D_OUT, zi->pi[3].double_out);

		// IvV
		CheckDlgButton(hDlg, IDC_CHECK_BULL, zi->op_bull);
		CheckDlgButton(hDlg, IDC_CHECK_STATS80PER, zi->stats_80per);

		set_enable(hDlg);

		SetWindowLong(hDlg, GWL_USERDATA, lParam);
		break;

	case WM_CLOSE:
		EndDialog(hDlg, FALSE);
		break;

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDC_RADIO_301:
		case IDC_RADIO_501:
		case IDC_RADIO_1001:
		case IDC_RADIO_ETC:
			EnableWindow(GetDlgItem(hDlg, IDC_EDIT_SCORE), FALSE);
			if (IsDlgButtonChecked(hDlg, IDC_RADIO_301) == 1) {
				SetDlgItemInt(hDlg, IDC_EDIT_ROUND, 10, FALSE);
			} else if (IsDlgButtonChecked(hDlg, IDC_RADIO_501) == 1) {
				SetDlgItemInt(hDlg, IDC_EDIT_ROUND, 15, FALSE);
			} else if (IsDlgButtonChecked(hDlg, IDC_RADIO_1001) == 1) {
				SetDlgItemInt(hDlg, IDC_EDIT_ROUND, 20, FALSE);
			} else {
				EnableWindow(GetDlgItem(hDlg, IDC_EDIT_SCORE), TRUE);
				SetDlgItemInt(hDlg, IDC_EDIT_ROUND, ZEROONE_ROUND_MAX, FALSE);
			}
			break;

		case IDC_RADIO_P1:
		case IDC_RADIO_P2:
		case IDC_RADIO_P3:
		case IDC_RADIO_P4:
			set_enable(hDlg);
			break;

		case IDCANCEL:
			SendMessage(hDlg, WM_CLOSE, 0, 0);
			break;

		case IDOK:
		case IDC_BUTTON_SAVE:
			zi = (ZEROONE_INFO *)GetWindowLong(hDlg, GWL_USERDATA);
			if (zi == NULL) {
				EndDialog(hDlg, FALSE);
				break;
			}
			// 
			ZeroMemory(zi, sizeof(ZEROONE_INFO));

			// XRA擾
			if (IsDlgButtonChecked(hDlg, IDC_RADIO_301) == 1) {
				zi->init_score = 301;
			} else if (IsDlgButtonChecked(hDlg, IDC_RADIO_501) == 1) {
				zi->init_score = 501;
			} else if (IsDlgButtonChecked(hDlg, IDC_RADIO_1001) == 1) {
				zi->init_score = 1001;
			} else {
				zi->init_score = GetDlgItemInt(hDlg, IDC_EDIT_SCORE, NULL, FALSE);
				if (zi->init_score <= 1) {
					zi->init_score = 501;
				}
				if (zi->init_score > 180 * ZEROONE_ROUND_MAX) {
					zi->init_score = 180 * ZEROONE_ROUND_MAX;
				}
			}
			zi->round_cnt = GetDlgItemInt(hDlg, IDC_EDIT_ROUND, NULL, FALSE);
			if (zi->round_cnt <= 0 || zi->round_cnt > ZEROONE_ROUND_MAX) {
				zi->round_cnt = ZEROONE_ROUND_MAX;
			}

			// vC[擾
			if (IsDlgButtonChecked(hDlg, IDC_RADIO_P1) == 1) {
				zi->player_cnt = 1;
			} else if (IsDlgButtonChecked(hDlg, IDC_RADIO_P2) == 1) {
				zi->player_cnt = 2;
			} else if (IsDlgButtonChecked(hDlg, IDC_RADIO_P3) == 1) {
				zi->player_cnt = 3;
			} else if (IsDlgButtonChecked(hDlg, IDC_RADIO_P4) == 1) {
				zi->player_cnt = 4;
			}
			for (i = 0; i < zi->player_cnt; i++) {
				zi->pi[i].score = zi->init_score;
			}
			// O
			SendDlgItemMessage(hDlg, IDC_EDIT_P1, WM_GETTEXT, BUF_SIZE - 1, (LPARAM)zi->pi[0].name);
			SendDlgItemMessage(hDlg, IDC_EDIT_P2, WM_GETTEXT, BUF_SIZE - 1, (LPARAM)zi->pi[1].name);
			SendDlgItemMessage(hDlg, IDC_EDIT_P3, WM_GETTEXT, BUF_SIZE - 1, (LPARAM)zi->pi[2].name);
			SendDlgItemMessage(hDlg, IDC_EDIT_P4, WM_GETTEXT, BUF_SIZE - 1, (LPARAM)zi->pi[3].name);
			// _uC
			zi->pi[0].double_in = IsDlgButtonChecked(hDlg, IDC_CHECK_P1_D_IN);
			zi->pi[1].double_in = IsDlgButtonChecked(hDlg, IDC_CHECK_P2_D_IN);
			zi->pi[2].double_in = IsDlgButtonChecked(hDlg, IDC_CHECK_P3_D_IN);
			zi->pi[3].double_in = IsDlgButtonChecked(hDlg, IDC_CHECK_P4_D_IN);
			// _uAEg
			zi->pi[0].double_out = IsDlgButtonChecked(hDlg, IDC_CHECK_P1_D_OUT);
			zi->pi[1].double_out = IsDlgButtonChecked(hDlg, IDC_CHECK_P2_D_OUT);
			zi->pi[2].double_out = IsDlgButtonChecked(hDlg, IDC_CHECK_P3_D_OUT);
			zi->pi[3].double_out = IsDlgButtonChecked(hDlg, IDC_CHECK_P4_D_OUT);

			// IvV
			zi->op_bull = IsDlgButtonChecked(hDlg, IDC_CHECK_BULL);
			zi->stats_80per = IsDlgButtonChecked(hDlg, IDC_CHECK_STATS80PER);

			if (LOWORD(wParam) == IDC_BUTTON_SAVE) {
				// ݒۑ
				ini_put_01game_option(ini_path, zi);
				MessageBox(hDlg, message_get_res(IDS_STRING_OP_GAME_SAVE), APP_NAME, MB_ICONINFORMATION);
			} else {
				// OK{^
				EndDialog(hDlg, TRUE);
			}
			break;
		}
		break;

	default:
		return FALSE;
	}
	return TRUE;
}

/*
 * set_option_01 - 01Q[ݒ
 */
BOOL set_option_01(const HINSTANCE hInst, const HWND hWnd, ZEROONE_INFO *zi)
{
	return DialogBoxParam(hInst, MAKEINTRESOURCE(IDD_DIALOG_OP_01), hWnd, option_01_proc, (LPARAM)zi);
}
/* End of source */
