/*
 * nScore
 *
 * score_countup_list.c
 *
 * Copyright (C) 1996-2003 by Nakashima Tomoaki. All rights reserved.
 *		http://www.nakka.com/
 *		nakka@nakka.com
 */

/* Include Files */
#define _INC_OLE
#include <windows.h>
#undef  _INC_OLE
#include <commctrl.h>
#include <tchar.h>
#include <stdio.h>

#include "General.h"
#include "String.h"
#include "Message.h"
#include "score_countup.h"
#include "score_input.h"

#include "resource.h"

/* Define */
#define WM_CHANGE_VIEW				(WM_APP + 1)

#define IsNumeric(c)				(c >= TEXT('0') && c <= TEXT('9'))

/* Global Variables */

/* Local Function Prototypes */
static BOOL get_status(COUNTUP_INFO *cui, const int round, TCHAR *ret);
static void listview_set_score(const HWND hListView, COUNTUP_INFO *cui);
static BOOL CALLBACK score_countup_list_proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);

/*
 * get_status - Xe[^X̎擾
 */
static BOOL get_status(COUNTUP_INFO *cui, const int round, TCHAR *ret)
{
	TCHAR throw_str[THROW_MAX][BUF_SIZE];
	int round_score;
	int i;

	if (round == 0) {
		round_score = cui->pi[cui->list_index].ri[round].score_list;
	} else {
		round_score = cui->pi[cui->list_index].ri[round].score_list - cui->pi[cui->list_index].ri[round - 1].score_list;
	}
	for (i = 0; i < THROW_MAX; i++) {
		lstrcpy(throw_str[i], cui->pi[cui->list_index].ri[round].throw_list[i]);
		score_convert_str(throw_str[i]);
	}
	return get_status_string(throw_str, round_score, ret);
}

/*
 * listview_set_score - ListViewɃXRAǉ
 */
static void listview_set_score(const HWND hListView, COUNTUP_INFO *cui)
{
	LV_ITEM lvi;
	TCHAR buf[BUF_SIZE];
	int i, cnt;

	ListView_DeleteAllItems(hListView);

	cnt = cui->current_round;
	if ((cui->current_player <= cui->list_index && (cui->game_flag == TRUE || cui->current_player != cui->list_index)) ||
		(cnt > cui->round_cnt && cui->list_index == 0)) {
		cnt--;
	}
	for (i = 0; i < cnt; i++) {
		lvi.mask = LVIF_TEXT | LVIF_PARAM;
		lvi.iItem = i;
		lvi.iSubItem = 0;
		wsprintf(buf, TEXT("%d"), i + 1);
		lvi.pszText = buf;
		lvi.cchTextMax = BUF_SIZE - 1;
		lvi.iImage = 0;
		lvi.lParam = 0;
		ListView_InsertItem(hListView, &lvi);

		ListView_SetItemText(hListView, i, 1, cui->pi[cui->list_index].ri[i].throw_list[0]);
		ListView_SetItemText(hListView, i, 2, cui->pi[cui->list_index].ri[i].throw_list[1]);
		ListView_SetItemText(hListView, i, 3, cui->pi[cui->list_index].ri[i].throw_list[2]);

		if (i == 0) {
			wsprintf(buf, TEXT("%d"), cui->pi[cui->list_index].ri[i].score_list);
		} else {
			wsprintf(buf, TEXT("%d"), cui->pi[cui->list_index].ri[i].score_list - cui->pi[cui->list_index].ri[i - 1].score_list);
		}
		ListView_SetItemText(hListView, i, 4, buf);

		wsprintf(buf, TEXT("%d"), cui->pi[cui->list_index].ri[i].score_list);
		ListView_SetItemText(hListView, i, 5, buf);

		if (get_status(cui, i, buf) == TRUE) {
			ListView_SetItemText(hListView, i, 6, buf);
		}
	}
}

/*
 * score_countup_list_proc - EBhEvV[W
 */
static BOOL CALLBACK score_countup_list_proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	COUNTUP_INFO *cui;
	LV_COLUMN lvc;
	TCHAR buf[BUF_SIZE];
	int i, cnt;
	float avg;

	switch (msg) {
	case WM_INITDIALOG:
		if ((cui = (COUNTUP_INFO *)lParam) == NULL) {
			EndDialog(hDlg, FALSE);
			break;
		}
		SetWindowLong(hDlg, GWL_USERDATA, lParam);

		// vC[ݒ
		for (i = 0; i < cui->player_cnt; i++) {
			SendDlgItemMessage(hDlg, IDC_COMBO_NAME, CB_ADDSTRING, 0, (LPARAM)cui->pi[i].name);
		}
		SendDlgItemMessage(hDlg, IDC_COMBO_NAME, CB_SETCURSEL, cui->list_index, 0);

		// Xgr[ݒ
		i = 0;
		lvc.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;

		lvc.fmt = LVCFMT_LEFT;
		lvc.cx = 60;
		lvc.pszText = message_get_res(IDS_STRING_LIST_ROUND);
		lvc.iSubItem = i++;
		ListView_InsertColumn(GetDlgItem(hDlg, IDC_LIST_SCORE), lvc.iSubItem, &lvc);

		lvc.fmt = LVCFMT_LEFT;
		lvc.cx = 80;
		lvc.pszText = message_get_res(IDS_STRING_LIST_THROW_1);
		lvc.iSubItem = i++;
		ListView_InsertColumn(GetDlgItem(hDlg, IDC_LIST_SCORE), lvc.iSubItem, &lvc);
		
		lvc.fmt = LVCFMT_LEFT;
		lvc.cx = 80;
		lvc.pszText = message_get_res(IDS_STRING_LIST_THROW_2);
		lvc.iSubItem = i++;
		ListView_InsertColumn(GetDlgItem(hDlg, IDC_LIST_SCORE), lvc.iSubItem, &lvc);

		lvc.fmt = LVCFMT_LEFT;
		lvc.cx = 80;
		lvc.pszText = message_get_res(IDS_STRING_LIST_THROW_3);
		lvc.iSubItem = i++;
		ListView_InsertColumn(GetDlgItem(hDlg, IDC_LIST_SCORE), lvc.iSubItem, &lvc);

		lvc.fmt = LVCFMT_LEFT;
		lvc.cx = 60;
		lvc.pszText = message_get_res(IDS_STRING_LIST_ROUND_SCORE);
		lvc.iSubItem = i++;
		ListView_InsertColumn(GetDlgItem(hDlg, IDC_LIST_SCORE), lvc.iSubItem, &lvc);

		lvc.fmt = LVCFMT_LEFT;
		lvc.cx = 60;
		lvc.pszText = message_get_res(IDS_STRING_LIST_SCORE);
		lvc.iSubItem = i++;
		ListView_InsertColumn(GetDlgItem(hDlg, IDC_LIST_SCORE), lvc.iSubItem, &lvc);

		lvc.fmt = LVCFMT_LEFT;
		lvc.cx = 100;
		lvc.pszText = message_get_res(IDS_STRING_LIST_STATUS);
		lvc.iSubItem = i++;
		ListView_InsertColumn(GetDlgItem(hDlg, IDC_LIST_SCORE), lvc.iSubItem, &lvc);

		// Xgr[̃X^C̐ݒ
		SetWindowLong(GetDlgItem(hDlg, IDC_LIST_SCORE), GWL_STYLE,
			GetWindowLong(GetDlgItem(hDlg, IDC_LIST_SCORE), GWL_STYLE) | LVS_SHOWSELALWAYS);
		SendDlgItemMessage(hDlg, IDC_LIST_SCORE, LVM_SETEXTENDEDLISTVIEWSTYLE, 0,
			LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES |
			SendDlgItemMessage(hDlg, IDC_LIST_SCORE, LVM_GETEXTENDEDLISTVIEWSTYLE, 0, 0));

	case WM_CHANGE_VIEW:
		cui = (COUNTUP_INFO *)GetWindowLong(hDlg, GWL_USERDATA);
		if (cui == NULL) {
			EndDialog(hDlg, FALSE);
			break;
		}
		cui->list_index = SendDlgItemMessage(hDlg, IDC_COMBO_NAME, CB_GETCURSEL, 0, 0);

		// Ax[Wݒ
		cnt = cui->current_round;
		if ((cui->current_player <= cui->list_index && (cui->game_flag == TRUE || cui->current_player != cui->list_index)) ||
			(cnt > cui->round_cnt && cui->list_index == 0)) {
			cnt--;
		} 
		if (cnt > 0) {
			avg = (float)cui->pi[cui->list_index].score / (float)cnt;
		} else {
			avg = 0;
		}
		_stprintf(buf, message_get_res(IDS_STRING_AVERAGE), (float)avg);
		SetWindowText(GetDlgItem(hDlg, IDC_STATIC_AVERAGE), buf);

		// XRAݒ
		listview_set_score(GetDlgItem(hDlg, IDC_LIST_SCORE), cui);
		break;

	case WM_CLOSE:
		EndDialog(hDlg, FALSE);
		break;

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDC_COMBO_NAME:
			if(HIWORD(wParam) == CBN_SELCHANGE){
				SendMessage(hDlg, WM_CHANGE_VIEW, 0, 0);
			}
			break;

		case IDCANCEL:
			SendMessage(hDlg, WM_CLOSE, 0, 0);
			break;
		}
		break;

	default:
		return FALSE;
	}
	return TRUE;
}

/*
 * show_score_countup_list - XRAꗗ\
 */
BOOL show_score_countup_list(const HINSTANCE hInst, const HWND hWnd, COUNTUP_INFO *cui)
{
	return DialogBoxParam(hInst, MAKEINTRESOURCE(IDD_DIALOG_SCORE_LIST), hWnd, score_countup_list_proc, (LPARAM)cui);
}
/* End of source */
