/*
 * nScore
 *
 * score_cricket_countup.h
 *
 * Copyright (C) 1996-2003 by Nakashima Tomoaki. All rights reserved.
 *		http://www.nakka.com/
 *		nakka@nakka.com
 */

#ifndef _INC_SCORE_CRICKET_COUNTUP_H
#define _INC_SCORE_CRICKET_COUNTUP_H

/* Include Files */
#include "general.h"

/* Define */
#define CRICKET_COUNTUP_ROUND_MAX			8
#define NUMBER_CNT							7

/* Struct */
typedef struct _CRICKET_COUNTUP_ROUND_INFO {
	int score_list;
	int mark_list;
	int mark[26];
	TCHAR throw_list[THROW_MAX][BUF_SIZE];
} CRICKET_COUNTUP_ROUND_INFO;

typedef struct _CRICKET_COUNTUP_PLAYER_INFO {
	TCHAR name[BUF_SIZE];
	int score;

	CRICKET_COUNTUP_ROUND_INFO ri[CRICKET_COUNTUP_ROUND_MAX];
} CRICKET_COUNTUP_PLAYER_INFO;

typedef struct _CRICKET_COUNTUP_INFO {
	BOOL game_flag;

	int player_cnt;
	int round_cnt;
	BOOL op_bull;

	int current_round;
	int current_player;
	int list_index;

	int number[CRICKET_COUNTUP_ROUND_MAX];

	CRICKET_COUNTUP_PLAYER_INFO pi[PLAYER_MAX];

} CRICKET_COUNTUP_INFO;

/* Function Prototypes */
BOOL score_cricket_countup_regist(const HINSTANCE hInstance);
HWND score_cricket_countup_create(const HINSTANCE hInstance, const HWND pWnd, int id, const int height);

#endif
/* End of source */
