/*
 * nScore
 *
 * score_cricket_list.c
 *
 * Copyright (C) 1996-2005 by Nakashima Tomoaki. All rights reserved.
 *		http://www.nakka.com/
 *		nakka@nakka.com
 */

/* Include Files */
#define _INC_OLE
#include <windows.h>
#undef  _INC_OLE
#include <commctrl.h>
#include <tchar.h>
#include <stdio.h>

#include "General.h"
#include "String.h"
#include "Message.h"
#include "score_cricket.h"

#include "resource.h"

/* Define */
#define WM_CHANGE_VIEW				(WM_APP + 1)

#define IsNumeric(c)				(c >= TEXT('0') && c <= TEXT('9'))

/* Global Variables */

/* Local Function Prototypes */
static void listview_set_score(const HWND hListView, CRICKET_INFO *cri);
static BOOL CALLBACK score_cricket_list_proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);

/*
 * listview_set_score - ListViewɃXRAǉ
 */
static void listview_set_score(const HWND hListView, CRICKET_INFO *cri)
{
	LV_ITEM lvi;
	TCHAR buf[BUF_SIZE];
	int i, cnt;

	ListView_DeleteAllItems(hListView);

	cnt = cri->current_round;
	if ((cri->current_player <= cri->list_index && (cri->game_flag == TRUE || cri->current_player != cri->list_index)) ||
		(cnt > cri->round_cnt && cri->list_index == 0)) {
		cnt--;
	}
	for (i = 0; i < cnt; i++) {
		if (cri->pi[cri->list_index].ri[i].score_list == -1) {
			break;
		}
		lvi.mask = LVIF_TEXT | LVIF_PARAM;
		lvi.iItem = i;
		lvi.iSubItem = 0;
		wsprintf(buf, TEXT("%d"), i + 1);
		lvi.pszText = buf;
		lvi.cchTextMax = BUF_SIZE - 1;
		lvi.iImage = 0;
		lvi.lParam = 0;
		ListView_InsertItem(hListView, &lvi);

		ListView_SetItemText(hListView, i, 1, cri->pi[cri->list_index].ri[i].throw_list[0]);
		ListView_SetItemText(hListView, i, 2, cri->pi[cri->list_index].ri[i].throw_list[1]);
		ListView_SetItemText(hListView, i, 3, cri->pi[cri->list_index].ri[i].throw_list[2]);
		if (cri->pi[cri->list_index].ri[i].mark_cnt != -1) {
			wsprintf(buf, TEXT("%d"), cri->pi[cri->list_index].ri[i].mark_cnt);
			ListView_SetItemText(hListView, i, 4, buf);
		}
		wsprintf(buf, TEXT("%d"), cri->pi[cri->list_index].ri[i].score_list);
		ListView_SetItemText(hListView, i, 5, buf);
	}
}

/*
 * score_cricket_list_proc - EBhEvV[W
 */
static BOOL CALLBACK score_cricket_list_proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	CRICKET_INFO *cri;
	LV_COLUMN lvc;
	TCHAR buf[BUF_SIZE];
	int i;

	switch (msg) {
	case WM_INITDIALOG:
		if ((cri = (CRICKET_INFO *)lParam) == NULL) {
			EndDialog(hDlg, FALSE);
			break;
		}
		SetWindowLong(hDlg, GWL_USERDATA, lParam);

		// vC[ݒ
		for (i = 0; i < cri->player_cnt; i++) {
			if (cri->pi[i].robo == FALSE) {
				SendDlgItemMessage(hDlg, IDC_COMBO_NAME, CB_ADDSTRING, 0, (LPARAM)cri->pi[i].name);
			} else {
				wsprintf(buf, message_get_res(IDS_STRING_ROBO_NAME), i + 1);
				SendDlgItemMessage(hDlg, IDC_COMBO_NAME, CB_ADDSTRING, 0, (LPARAM)buf);
			}
		}
		SendDlgItemMessage(hDlg, IDC_COMBO_NAME, CB_SETCURSEL, cri->list_index, 0);

		// Xgr[ݒ
		i = 0;
		lvc.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;

		lvc.fmt = LVCFMT_LEFT;
		lvc.cx = 60;
		lvc.pszText = message_get_res(IDS_STRING_LIST_ROUND);
		lvc.iSubItem = i++;
		ListView_InsertColumn(GetDlgItem(hDlg, IDC_LIST_SCORE), lvc.iSubItem, &lvc);

		lvc.fmt = LVCFMT_LEFT;
		lvc.cx = 80;
		lvc.pszText = message_get_res(IDS_STRING_LIST_THROW_1);
		lvc.iSubItem = i++;
		ListView_InsertColumn(GetDlgItem(hDlg, IDC_LIST_SCORE), lvc.iSubItem, &lvc);

		lvc.fmt = LVCFMT_LEFT;
		lvc.cx = 80;
		lvc.pszText = message_get_res(IDS_STRING_LIST_THROW_2);
		lvc.iSubItem = i++;
		ListView_InsertColumn(GetDlgItem(hDlg, IDC_LIST_SCORE), lvc.iSubItem, &lvc);

		lvc.fmt = LVCFMT_LEFT;
		lvc.cx = 80;
		lvc.pszText = message_get_res(IDS_STRING_LIST_THROW_3);
		lvc.iSubItem = i++;
		ListView_InsertColumn(GetDlgItem(hDlg, IDC_LIST_SCORE), lvc.iSubItem, &lvc);

		lvc.fmt = LVCFMT_LEFT;
		lvc.cx = 60;
		lvc.pszText = message_get_res(IDS_STRING_MARK);
		lvc.iSubItem = i++;
		ListView_InsertColumn(GetDlgItem(hDlg, IDC_LIST_SCORE), lvc.iSubItem, &lvc);

		lvc.fmt = LVCFMT_LEFT;
		lvc.cx = 60;
		lvc.pszText = message_get_res(IDS_STRING_LIST_SCORE);
		lvc.iSubItem = i++;
		ListView_InsertColumn(GetDlgItem(hDlg, IDC_LIST_SCORE), lvc.iSubItem, &lvc);

		// Xgr[̃X^C̐ݒ
		SetWindowLong(GetDlgItem(hDlg, IDC_LIST_SCORE), GWL_STYLE,
			GetWindowLong(GetDlgItem(hDlg, IDC_LIST_SCORE), GWL_STYLE) | LVS_SHOWSELALWAYS);
		SendDlgItemMessage(hDlg, IDC_LIST_SCORE, LVM_SETEXTENDEDLISTVIEWSTYLE, 0,
			LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES |
			SendDlgItemMessage(hDlg, IDC_LIST_SCORE, LVM_GETEXTENDEDLISTVIEWSTYLE, 0, 0));

	case WM_CHANGE_VIEW:
		cri = (CRICKET_INFO *)GetWindowLong(hDlg, GWL_USERDATA);
		if (cri == NULL) {
			EndDialog(hDlg, FALSE);
			break;
		}
		cri->list_index = SendDlgItemMessage(hDlg, IDC_COMBO_NAME, CB_GETCURSEL, 0, 0);

		_stprintf(buf, message_get_res(IDS_STRING_AVERAGE), get_cricket_average(cri, cri->list_index, NULL, NULL));
		SetWindowText(GetDlgItem(hDlg, IDC_STATIC_AVERAGE), buf);

		// XRAݒ
		listview_set_score(GetDlgItem(hDlg, IDC_LIST_SCORE), cri);
		break;

	case WM_CLOSE:
		EndDialog(hDlg, FALSE);
		break;

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDC_COMBO_NAME:
			if(HIWORD(wParam) == CBN_SELCHANGE){
				SendMessage(hDlg, WM_CHANGE_VIEW, 0, 0);
			}
			break;

		case IDCANCEL:
			SendMessage(hDlg, WM_CLOSE, 0, 0);
			break;
		}
		break;

	default:
		return FALSE;
	}
	return TRUE;
}

/*
 * show_score_cricket_list - XRAꗗ\
 */
BOOL show_score_cricket_list(const HINSTANCE hInst, const HWND hWnd, CRICKET_INFO *cri)
{
	return DialogBoxParam(hInst, MAKEINTRESOURCE(IDD_DIALOG_SCORE_LIST), hWnd, score_cricket_list_proc, (LPARAM)cri);
}
/* End of source */
