/*
 * nScore
 *
 * score_eagleseye.h
 *
 * Copyright (C) 1996-2003 by Nakashima Tomoaki. All rights reserved.
 *		http://www.nakka.com/
 *		nakka@nakka.com
 */

#ifndef _INC_SCORE_EAGLESEYE_H
#define _INC_SCORE_EAGLESEYE_H

/* Include Files */
#include "general.h"

/* Define */
#define EAGLESEYE_ROUND_MAX			8

/* Struct */
typedef struct _EAGLESEYE_ROUND_INFO {
	int score_list;
	int cnt_s_bull;
	int cnt_d_bull;
	TCHAR throw_list[THROW_MAX][BUF_SIZE];
} EAGLESEYE_ROUND_INFO;

typedef struct _EAGLESEYE_PLAYER_INFO {
	TCHAR name[BUF_SIZE];
	int score;

	EAGLESEYE_ROUND_INFO ri[EAGLESEYE_ROUND_MAX];
} EAGLESEYE_PLAYER_INFO;

typedef struct _EAGLESEYE_INFO {
	BOOL game_flag;

	int player_cnt;
	int round_cnt;
	BOOL op_bull;

	int current_round;
	int current_player;
	int list_index;

	EAGLESEYE_PLAYER_INFO pi[PLAYER_MAX];

} EAGLESEYE_INFO;

/* Function Prototypes */
BOOL score_eagleseye_regist(const HINSTANCE hInstance);
HWND score_eagleseye_create(const HINSTANCE hInstance, const HWND pWnd, int id, const int height);

#endif
/* End of source */
