/*
 * nScore
 *
 * score_halfit.h
 *
 * Copyright (C) 1996-2003 by Nakashima Tomoaki. All rights reserved.
 *		http://www.nakka.com/
 *		nakka@nakka.com
 */

#ifndef _INC_SCORE_HALFIT_H
#define _INC_SCORE_HALFIT_H

/* Include Files */
#include "general.h"

/* Define */
#define HALFIT_ROUND_MAX			9
#define HALFIT_INIT_SCORE			40

/* Struct */
typedef struct _HALFIT_ROUND_INFO {
	int score_list;
	TCHAR throw_list[THROW_MAX][BUF_SIZE];
} HALFIT_ROUND_INFO;

typedef struct _HALFIT_PLAYER_INFO {
	TCHAR name[BUF_SIZE];
	int score;

	HALFIT_ROUND_INFO ri[HALFIT_ROUND_MAX];
} HALFIT_PLAYER_INFO;

typedef struct _HALFIT_INFO {
	BOOL game_flag;

	int player_cnt;
	int round_cnt;
	BOOL op_bull;

	int current_round;
	int current_player;
	int list_index;

	TCHAR number[HALFIT_ROUND_MAX];

	HALFIT_PLAYER_INFO pi[PLAYER_MAX];

} HALFIT_INFO;

/* Function Prototypes */
BOOL score_halfit_regist(const HINSTANCE hInstance);
HWND score_halfit_create(const HINSTANCE hInstance, const HWND pWnd, int id, const int height);

#endif
/* End of source */
