/*
 * nScore
 *
 * score_splat.h
 *
 * Copyright (C) 1996-2003 by Nakashima Tomoaki. All rights reserved.
 *		http://www.nakka.com/
 *		nakka@nakka.com
 */

#ifndef _INC_SCORE_SPLAT_H
#define _INC_SCORE_SPLAT_H

/* Include Files */
#include "general.h"

/* Define */
#define SPLAT_ROUND_MAX			50

/* Struct */
typedef struct _SPLAT_ROUND_INFO {
	int splats;
	int score_list;
	int prev_score_list[PLAYER_MAX];
	TCHAR throw_list[THROW_MAX][BUF_SIZE];
} SPLAT_ROUND_INFO;

typedef struct _SPLAT_PLAYER_INFO {
	TCHAR name[BUF_SIZE];
	int score;

	BOOL half;

	BOOL double_in;
	int double_in_flag;
	BOOL double_out;
	BOOL master_splat;
	int master_splat_flag;

	SPLAT_ROUND_INFO ri[SPLAT_ROUND_MAX];
} SPLAT_PLAYER_INFO;

typedef struct _SPLAT_INFO {
	BOOL game_flag;

	int player_cnt;
	int round_cnt;
	BOOL op_bull;

	int current_round;
	int current_player;
	int list_index;

	SPLAT_PLAYER_INFO pi[PLAYER_MAX];

} SPLAT_INFO;

/* Function Prototypes */
BOOL score_splat_regist(const HINSTANCE hInstance);
HWND score_splat_create(const HINSTANCE hInstance, const HWND pWnd, int id, const int height);

#endif
/* End of source */
