/*
 * nScore
 *
 * score_splat_list.c
 *
 * Copyright (C) 1996-2003 by Nakashima Tomoaki. All rights reserved.
 *		http://www.nakka.com/
 *		nakka@nakka.com
 */

/* Include Files */
#define _INC_OLE
#include <windows.h>
#undef  _INC_OLE
#include <commctrl.h>
#include <tchar.h>
#include <stdio.h>

#include "General.h"
#include "String.h"
#include "Message.h"
#include "score_splat.h"
#include "score_input.h"

#include "resource.h"

/* Define */
#define WM_CHANGE_VIEW				(WM_APP + 1)

#define IsNumeric(c)				(c >= TEXT('0') && c <= TEXT('9'))

/* Global Variables */

/* Local Function Prototypes */
static void listview_set_score(const HWND hListView, SPLAT_INFO *si);
static BOOL CALLBACK score_splat_list_proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);

/*
 * listview_set_score - ListViewɃXRAǉ
 */
static void listview_set_score(const HWND hListView, SPLAT_INFO *si)
{
	LV_ITEM lvi;
	TCHAR buf[BUF_SIZE];
	int i, cnt;

	ListView_DeleteAllItems(hListView);

	cnt = si->current_round;
	if ((si->current_player <= si->list_index && (si->game_flag == TRUE || si->current_player != si->list_index)) ||
		(cnt > si->round_cnt && si->list_index == 0)) {
		cnt--;
	}
	for (i = 0; i < cnt; i++) {
		lvi.mask = LVIF_TEXT | LVIF_PARAM;
		lvi.iItem = i;
		lvi.iSubItem = 0;
		wsprintf(buf, TEXT("%d"), i + 1);
		lvi.pszText = buf;
		lvi.cchTextMax = BUF_SIZE - 1;
		lvi.iImage = 0;
		lvi.lParam = 0;
		ListView_InsertItem(hListView, &lvi);

		ListView_SetItemText(hListView, i, 1, si->pi[si->list_index].ri[i].throw_list[0]);
		ListView_SetItemText(hListView, i, 2, si->pi[si->list_index].ri[i].throw_list[1]);
		ListView_SetItemText(hListView, i, 3, si->pi[si->list_index].ri[i].throw_list[2]);

		wsprintf(buf, TEXT("%d"), si->pi[si->list_index].ri[i].score_list);
		ListView_SetItemText(hListView, i, 4, buf);
	}
}

/*
 * score_splat_list_proc - EBhEvV[W
 */
static BOOL CALLBACK score_splat_list_proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	SPLAT_INFO *si;
	LV_COLUMN lvc;
	TCHAR buf[BUF_SIZE];
	int i, cnt;
	int splats;

	switch (msg) {
	case WM_INITDIALOG:
		if ((si = (SPLAT_INFO *)lParam) == NULL) {
			EndDialog(hDlg, FALSE);
			break;
		}
		SetWindowLong(hDlg, GWL_USERDATA, lParam);

		// vC[ݒ
		for (i = 0; i < si->player_cnt; i++) {
			SendDlgItemMessage(hDlg, IDC_COMBO_NAME, CB_ADDSTRING, 0, (LPARAM)si->pi[i].name);
		}
		SendDlgItemMessage(hDlg, IDC_COMBO_NAME, CB_SETCURSEL, si->list_index, 0);

		// Xgr[ݒ
		i = 0;
		lvc.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;

		lvc.fmt = LVCFMT_LEFT;
		lvc.cx = 60;
		lvc.pszText = message_get_res(IDS_STRING_LIST_ROUND);
		lvc.iSubItem = i++;
		ListView_InsertColumn(GetDlgItem(hDlg, IDC_LIST_SCORE), lvc.iSubItem, &lvc);

		lvc.fmt = LVCFMT_LEFT;
		lvc.cx = 80;
		lvc.pszText = message_get_res(IDS_STRING_LIST_THROW_1);
		lvc.iSubItem = i++;
		ListView_InsertColumn(GetDlgItem(hDlg, IDC_LIST_SCORE), lvc.iSubItem, &lvc);
		
		lvc.fmt = LVCFMT_LEFT;
		lvc.cx = 80;
		lvc.pszText = message_get_res(IDS_STRING_LIST_THROW_2);
		lvc.iSubItem = i++;
		ListView_InsertColumn(GetDlgItem(hDlg, IDC_LIST_SCORE), lvc.iSubItem, &lvc);

		lvc.fmt = LVCFMT_LEFT;
		lvc.cx = 80;
		lvc.pszText = message_get_res(IDS_STRING_LIST_THROW_3);
		lvc.iSubItem = i++;
		ListView_InsertColumn(GetDlgItem(hDlg, IDC_LIST_SCORE), lvc.iSubItem, &lvc);

		lvc.fmt = LVCFMT_LEFT;
		lvc.cx = 60;
		lvc.pszText = message_get_res(IDS_STRING_LIST_SCORE);
		lvc.iSubItem = i++;
		ListView_InsertColumn(GetDlgItem(hDlg, IDC_LIST_SCORE), lvc.iSubItem, &lvc);

		// Xgr[̃X^C̐ݒ
		SetWindowLong(GetDlgItem(hDlg, IDC_LIST_SCORE), GWL_STYLE,
			GetWindowLong(GetDlgItem(hDlg, IDC_LIST_SCORE), GWL_STYLE) | LVS_SHOWSELALWAYS);
		SendDlgItemMessage(hDlg, IDC_LIST_SCORE, LVM_SETEXTENDEDLISTVIEWSTYLE, 0,
			LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES |
			SendDlgItemMessage(hDlg, IDC_LIST_SCORE, LVM_GETEXTENDEDLISTVIEWSTYLE, 0, 0));

	case WM_CHANGE_VIEW:
		si = (SPLAT_INFO *)GetWindowLong(hDlg, GWL_USERDATA);
		if (si == NULL) {
			EndDialog(hDlg, FALSE);
			break;
		}
		si->list_index = SendDlgItemMessage(hDlg, IDC_COMBO_NAME, CB_GETCURSEL, 0, 0);

		cnt = si->current_round;
		if ((si->current_player <= si->list_index && (si->game_flag == TRUE || si->current_player != si->list_index)) ||
			(cnt > si->round_cnt && si->list_index == 0)) {
			cnt--;
		}
		splats = 0;
		for (i = 0; i < cnt; i++) {
			splats += si->pi[si->list_index].ri[i].splats;
		}
		wsprintf(buf, message_get_res(IDS_STRING_SPLATS), splats);
		SetWindowText(GetDlgItem(hDlg, IDC_STATIC_AVERAGE), buf);

		// XRAݒ
		listview_set_score(GetDlgItem(hDlg, IDC_LIST_SCORE), si);
		break;

	case WM_CLOSE:
		EndDialog(hDlg, FALSE);
		break;

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDC_COMBO_NAME:
			if(HIWORD(wParam) == CBN_SELCHANGE){
				SendMessage(hDlg, WM_CHANGE_VIEW, 0, 0);
			}
			break;

		case IDCANCEL:
			SendMessage(hDlg, WM_CLOSE, 0, 0);
			break;
		}
		break;

	default:
		return FALSE;
	}
	return TRUE;
}

/*
 * show_score_splat_list - XRAꗗ\
 */
BOOL show_score_splat_list(const HINSTANCE hInst, const HWND hWnd, SPLAT_INFO *si)
{
	return DialogBoxParam(hInst, MAKEINTRESOURCE(IDD_DIALOG_SCORE_LIST), hWnd, score_splat_list_proc, (LPARAM)si);
}
/* End of source */
